<template>
  <div>
    <div>
<CModal
      title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Plant Master</h5>
   
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter 
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped 
      border
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectPlant(item)"> Edit </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectPlant(item)" >Delete</CButton>
      <!-- <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectPlant(item)"> Details </CButton> -->
    </template>
    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> New Plant</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">New Plant</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<div class="form-group"><label>Plant Code</label>
<input type="text" name="plantCode" class="form-control form-control-sm"  v-model="newPlant.plantCode">
</div>
<div class="form-group"><label> Name</label>
<input type="text" name="plant_Name" class="form-control form-control-sm"  v-model="newPlant.plantName">
</div>

<div class="form-group"><label> Address</label>
<input type="text" name="plant_Address" class="form-control form-control-sm"  v-model="newPlant.plantAddress">
</div>
<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addPlants();" > Add Plant </CButton>
</div>
</form>
 </div>
</div>
</div>
 </div>


<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">
<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Plant</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group"><label>Plant Code</label>
<input type="text" name="plantCode"  class="form-control form-control-sm" v-model="CurrentPlant.plantCode">
</div>

<div class="form-group"><label>Plant Name</label>
<input type="text" name="plant_Name" class="form-control form-control-sm"  v-model="CurrentPlant.plantName">
</div>

<div class="form-group"><label>Plant Address</label>
<input type="text" name="plant_Address" class="form-control form-control-sm"  v-model="CurrentPlant.plantAddress">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false; SelectPlant(CurrentPlant);UpdatePlants();" > Update Plant </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Plant</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the Plant ? </h4>
<h5> You are deleting {{ this.CurrentPlant.plantId +' || '+ this.CurrentPlant.plantName }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem(); "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>
<script>
const items = [
   
             { key: 'plantId', _style:'min-width:100px;' },
             { key: 'plantCode', _style:'min-width:100px;' },
             { key: 'plantAddress', _style:'min-width:50px;' }, 
             { key: 'plantStatus',     _style: 'width:1%',  },
 ]   
 const apiget =  'PlantMaster/'

import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {

  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
         
             { key: 'plantCode',    label:'Plant Code',   _style: 'width:20%',  },       
             { key: 'plantName',    label:'Plant Name',   _style: 'width:20%',  },       
             { key: 'plantAddress',   label:'Plant Address',   _style:'min-width:50px;' }, 
             { key: 'show_details',  label: '',  _style: 'width:30%', },      
      ],

  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentPlant:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newPlant: {plantId:0,plantCode:0,plantName:"",plantAddress:"",plantStaus:true,},
  
  }
  },
 

  
  mounted()
  {
   this.getAllPlantDetails();
  },

  methods:
  {
   getAllPlantDetails: function()
   {

   Vue.axios.get(this.$url+ apiget )
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data;
     

       }
    });
   },

   
  addPlants()
  {
   if(this.newPlant.plantCode == "" || this.newPlant.plantName == "" || this.newPlant.plantAddress == "" )
    {
     this.SuccessMsg = "Please enter all the fields";
     this.smallModal = true;
    }
    else if(this.newPlant.plantCode == 0 || this.newPlant.plantName == 0 || this.newPlant.plantAddress == 0 )
    {
      this.SuccessMsg = "Please enter valid data, Fields can' t be zero";
       this.smallModal = true;
    }

    else if(this.items.find(x => x.plantCode == this.newPlant.plantName && x.plantStaus == 1 ))
    {

     this.SuccessMsg= "Plant Code " + this.newPlant.plantName +" already exist. Please try another Code";
     this.smallModal = true;
      
    }
    else
     {


    Vue.axios.post(this.$url+ apiget ,this.newPlant).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        this.smallModal = true;
        this.getAllPlantDetails();
        location.reload();
       }
    })
     }
   },

  UpdatePlants()
  {
if(this.CurrentPlant.plantCode == "" || this.CurrentPlant.plantName == "" || this.CurrentPlant.plantAddress == "" )
    {
     this.SuccessMsg = "Please enter all the fields";
     this.smallModal = true;
    }
    else if(this.CurrentPlant.plantCode == 0 || this.CurrentPlant.plantName == 0 || this.CurrentPlant.plantAddress == 0 )
    {
      this.SuccessMsg = "Please enter valid data, Fields can' t be zero";
       this.smallModal = true;
    }

    else  if((this.CurrentPlant.plantCode != this.CurrentPlant.plantCode )&&(this.CurrentPlant.plantName != this.CurrentPlant.plantName ) && this.items.find(x => x.plantName == this.newPlant.plantName && x.plantStaus == 1 ))
      {
       this.SuccessMsg= "Plant name " + this.CurrentPlant.plant_Name +" already exist. Please try another Name";
       this.smallModal = true;
     }  
    
    else
     {
     
       this.CurrentPlant.plantId = this.CurrentPlant.plantId;
        Vue.axios.put(this.$url+ apiget +this.CurrentPlant.plantId,this.CurrentPlant).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
          this.getAllPlantDetails();
         location.reload();
         this.SuccessMsg ="Records Updated Successfully.."  
       }
    })
     }
   },

  deleteItem()
    {
      var plantId = this.CurrentPlant.plantId;
     
        axios({   method: 'delete',
           url: this.$url+ apiget + plantId
    }); 
 
       
        this.smallModal = true;
         this.SuccessMsg ="Records Updated Successfully.."  
    },
      
  SelectPlant(Plant)
    {
    
     this.CurrentPlant=Plant;
      
    },


    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>